LeetCode 456.132模式

给你一个整数数组 nums ,数组中共有 n 个整数。132 模式的子序列 由三个整数 numsi、numsj 和 numsk 组成,并同时满足:i < j < k 和 numsi < numsk < numsj 。

如果 nums 中存在 132 模式的子序列 ,返回 true ;否则,返回 false 。

示例 1:

输入:nums = 1,2,3,4

输出:false

解释:序列中不存在 132 模式的子序列。

示例 2:

输入:nums = 3,1,4,2

输出:true

解释:序列中有 1 个 132 模式的子序列: 1, 4, 2 。

示例 3:

输入:nums = -1,3,2,0

输出:true

解释:序列中有 3 个 132 模式的的子序列:-1, 3, 2、-1, 3, 0 和 -1, 2, 0 。

提示:

n == nums.length

1 <= n <= 2 * 105^55

-109^99 <= numsi <= 109^99

我们可以先预处理nums,将其中元素存放到一个有序集合multiset中,然后用变量preMin记录之前出现过的最小值(因为132模式中,最左边的数字越小越能满足该模式),之后就可以遍历nums,遍历到一个值时,先将其从multiset中删去,这保证了multiset中都是当前遍历的值右边的数字,然后找出multiset中第一个大于preMin的数字sufMax,然后看preMin、当前遍历的数、sufMax是否是132模式:

cpp 复制代码
class Solution {
public:
    bool find132pattern(vector<int>& nums) {
        int n = nums.size();

        multiset<int> right;
        for (int num : nums) {
            right.insert(num);
        }

        int preMin = 1e9 + 1;
        for (int i = 0; i < n - 1; ++i) {
            right.erase(right.find(nums[i]));

            auto it = right.lower_bound(preMin + 1);

            if (nums[i] > preMin && it != right.end() && *it < nums[i]) {
                return true;
            }

            preMin = min(preMin, nums[i]);
        }

        return false;
    }
};

如果nums的大小是n,则此算法时间复杂度为O(nlogn),空间复杂度为O(n)。

相关推荐
一去不复返的通信er6 小时前
力扣-图论-岛屿数量
算法·leetcode·图论
程序 代码狂人9 小时前
切片表与分区表的区别(数据开发面试版)
java·大数据·开发语言·数据仓库·算法
HDU-Dade9 小时前
【校招笔试真题】简要介绍 Self-Attention 的前沿算法
人工智能·算法
Xin77010 小时前
LeetCode 79. 单词搜索(DFS 回溯法)
leetcode
小郎君65812 小时前
Vue keep-alive 切标签后滚动位置回顶?因为 onDeactivated 里读到的 scrollTop 是 0
算法
邵奈一12 小时前
GPT-6.1 Terra速度是Sol的3倍,价格减半
算法
RaaS10012 小时前
Node.js Brotli RCE 漏洞自查指南:fetch、undici、axios 都在影响面,三分钟确认你的版本
人工智能·深度学习·算法
shehuiyuelaiyuehao12 小时前
算法56,重排链表
数据结构·算法·链表
qq_4523962313 小时前
第四篇:《索引原理与实战:B-tree、Hash、GIN、GiST、BRIN》
算法·哈希算法·gin